<%@ page language="java" session="true" %>
<%@page import="java.util.Date, java.text.DateFormat"%>
<%/*--------------------------------------------------------------------------------------|
|Copyright (c) 2007, SAS Institute, Inc.  All Rights Reserved.
|
|NAME: rules/rulesPrintableVersion.jsp
|DESCRIPTION: JSP page to print one or more rule definitions from a rule list (it fills in
|             in the standard rule-printing template supplied by the Action class)
|---------------------------------------------------------------------------------------*/%>


<%@ include file="/common/taglibs.jsp" %>
<%Date date = new Date();
String sdate = DateFormat.getDateInstance(DateFormat.FULL, request.getLocale()).format(date);
String stime = DateFormat.getTimeInstance(DateFormat.FULL, request.getLocale()).format(date);
String formattedCurrentDate = sdate + " " + stime; %>
<%@ page contentType="text/html; charset=UTF-8" %>
<style type=text/css>@import "common/styles/calendar.css";</style>

<script language="JavaScript" src="rules/scripts/rules.js"></script>
<script language='JavaScript' src='rules/scripts/ruleSasTest.js'></script>
<script language='JavaScript' src='rules/scripts/findReplace.js'></script>
<script language='JavaScript' src='rules/scripts/expander.js'></script>
<script language='JavaScript' src="common/scripts/calendar.js"></script>
<script language="JavaScript" src="rules/scripts/mylistboxAssignments.js"></script>
<script language="JavaScript" src="rules/scripts/users.js"></script>

<HTML>

<HEAD>
  <title>
   <c:choose>
	<c:when test="${empty productName}">
		<fmt:message key="creditfraud.application.title.txt" /> -
	</c:when>
	<c:otherwise>
		${fn:replace(fn:replace(productName, "<sup>", ""), "</sup>", "")} -
	</c:otherwise>
   </c:choose>
   Rules
  </title>
  <STYLE>
  TD {font-family: helvetica,ariel,sans-serif;
      vertical-align: top;
      color: black;
      font-size: x-small;
     }
  .toc { border:1px solid #dddddd;
       }
  </STYLE>
</HEAD>



<BODY marginheight="0" marginwidth="0" onload="adjustDatetimes();">



<%-- Set rule values that will be used in the included rule-print-layout file --%>
<c:set var="NONE" value="<span class='softNone'>None</span>"/>


<h2><c:choose>
	<c:when test="${empty productName}">
		<fmt:message key="creditfraud.application.title.txt" />
	</c:when>
	<c:otherwise>
		${productName}
	</c:otherwise>
</c:choose> Rules<br>
<span style="font-size:small;font-weight:normal;"><%=formattedCurrentDate %></span>
</h2>


<table width="100%" border="1" cellspacing="0" cellpadding="4" class="toc">
  <tr>  <th class="toc" nowrap align=left>Rule
        <th class="toc" nowrap align=left>Type
        <th class="toc" nowrap align=left>Name
        <th class="toc" nowrap align=left width="95%">Description
  </tr>
  <c:forEach var="r" items="${rules}">
    <tr><td class="toc" nowrap>Rule ${r.baseRuleId}.${r.version}
        <td class="toc" nowrap><c:if test="${empty r.ruleType}">${NONE}</c:if>${r.ruleType}
        <td class="toc" nowrap><c:if test="${empty r.name}">${NONE}</c:if>${fn:escapeXml(r.name)}  <%-- S0881932 --%>
        <td class="toc"><c:if test="${empty r.description || fn:trim(r.description)==''}">${NONE}</c:if>${fn:escapeXml(r.description)}  <%-- S0881932 --%>
    </tr>
  </c:forEach>
</table>
<br/>

<c:forEach var="r" items="${rules}">

   <div style="page-break-after:always;">&nbsp;</div>
   <hr>

   <c:set var="title">
     <c:choose>
        <c:when test="${empty r.baseRuleId && empty r.version && empty r.name}">${NONE}</c:when>
        <c:otherwise>Rule ${r.baseRuleId}.${r.version}: ${fn:escapeXml(r.name)}</c:otherwise>  <%-- S0881932 --%>
     </c:choose>
   </c:set>
   <c:set var="name">
     <c:choose>
        <c:when test="${empty r.name}">${NONE}</c:when>
        <c:otherwise><c:out value='${r.name}'/></c:otherwise>
     </c:choose>
   </c:set>
   <c:set var="baseRuleIdInfo">
     <c:choose>
        <c:when test="${empty r.baseRuleId && empty r.version && empty r.workflowState}">${NONE}</c:when>
        <c:otherwise>${r.baseRuleId}.${r.version} (${r.workflowState})</c:otherwise>
     </c:choose>
   </c:set>
   <c:set var="ruleBusinessUnitInfo">
     <c:choose>
        <c:when test="${empty r.businessUnitItem}">${NONE}</c:when>
        <c:otherwise>${r.businessUnitItem.buName} (${fn:trim(r.businessUnitItem.rootMultiOrgNodeKey)})</c:otherwise>
     </c:choose>
   </c:set>
   <c:set var="checkoutInfo">
     <c:choose>
        <c:when test="${empty r.checkoutTime || r.workflowState != 'Coding'}">${NONE}</c:when>
        <c:otherwise>${r.checkoutTime} by <c:out value='${fn:escapeXml(r.checkoutUser)}'/></c:otherwise>
     </c:choose>
   </c:set>
   <c:set var="createdInfo">
     <c:choose>
        <c:when test="${empty r.createTimestamp}">${NONE}</c:when>
        <c:otherwise><span dateFormat="${esapi:encodeForHTML(dateFormat)} ${esapi:encodeForHTML(timeFormat)}" dateValue="${r.createTimestampUtcMillis}"> </span> &nbsp;by ${fn:escapeXml(r.createUser)}</c:otherwise>
     </c:choose>
   </c:set>
   <c:set var="ruleTypeInfo">
     <c:choose>
        <c:when test="${empty r.ruleType}">${NONE}</c:when>
        <c:otherwise>${r.ruleType}</c:otherwise>
     </c:choose>
   </c:set>
   <c:set var="updatedInfo">
     <c:choose>
        <c:when test="${empty r.lastUpdateTimestamp}">${NONE}</c:when>
        <c:otherwise><span dateFormat="${esapi:encodeForHTML(dateFormat)} ${esapi:encodeForHTML(timeFormat)}" dateValue="${r.lastUpdateTimestampUtcMillis}"> </span> &nbsp;by ${fn:escapeXml(r.lastUpdateUser)}</c:otherwise>
     </c:choose>
   </c:set>
   <c:set var="multiOrgNodeId">
     <c:choose>
        <c:when test="${empty r.multiOrgNode}">${NONE}</c:when>
        <c:otherwise>${r.multiOrgNode.label} (${r.multiOrgNode.key})</c:otherwise>
     </c:choose>
   </c:set>
   <c:set var="queueId">
     <c:choose>
        <c:when test="${empty queueMap[r.id]}">${NONE}</c:when>
        <c:otherwise>${fn:escapeXml(queueMap[r.id].name)} (${queueMap[r.id].status})</c:otherwise>  <%-- S0881932 --%>
     </c:choose>
   </c:set>
   <c:set var="componentPreSet">
     <c:choose>
        <c:when test="${empty r.componentPreSetLabel}"><i>Custom</i></c:when>
        <c:otherwise>${r.componentPreSetLabel}</c:otherwise>
     </c:choose>
   </c:set>

   <c:set var="ACCOUNTValues" value=""/>
   <c:set var="ACTIVITYValues" value=""/>
   <c:set var="CHANNELValues" value=""/>
   <c:set var="AUTHENTICATIONValues" value=""/>
   <c:set var="CUSTOMERValues" value=""/>
   <c:forEach var="c" items="${r.components}">
     <c:choose>
      <c:when test="${fn:trim(c.componentType)=='ACCOUNT'}">  <c:set var="ACCOUNTValues">${ACCOUNTValues}, ${c.componentValueName}</c:set></c:when>
      <c:when test="${fn:trim(c.componentType)=='ACTIVITY'&& fn:trim(c.componentValue)!='NAP'}"> <c:set var="ACTIVITYValues">${ACTIVITYValues}, ${c.componentValueName}</c:set></c:when>
      <c:when test="${fn:trim(c.componentType)=='CHANNEL'}">  <c:set var="CHANNELValues">${CHANNELValues}, ${c.componentValueName}</c:set></c:when>
      <c:when test="${fn:trim(c.componentType)=='AUTHENTICATION'}"> <c:set var="AUTHENTICATIONValues">${AUTHENTICATIONValues}, ${c.componentValueName}</c:set></c:when>
      <c:when test="${fn:trim(c.componentType)=='CUSTOMER'}"> <c:set var="CUSTOMERValues">${CUSTOMERValues}, ${c.componentValueName}</c:set></c:when>
     </c:choose>
   </c:forEach>
   <c:choose> <c:when test="${empty ACCOUNTValues}"> <c:set var="ACCOUNTValues" value="<i>Not Relevant</i>"/> </c:when>
              <c:otherwise>                          <c:set var="ACCOUNTValues" value="${fn:substring(ACCOUNTValues,2,fn:length(ACCOUNTValues))}"/> </c:otherwise>
   </c:choose>
   <c:choose> <c:when test="${empty ACTIVITYValues}"><c:set var="ACTIVITYValues" value="<i>Not Relevant</i>"/> </c:when>
              <c:otherwise>                          <c:set var="ACTIVITYValues" value="${fn:substring(ACTIVITYValues,2,fn:length(ACTIVITYValues))}"/> </c:otherwise>
   </c:choose>
   <c:choose> <c:when test="${empty CHANNELValues}"> <c:set var="CHANNELValues" value="<i>Not Relevant</i>"/> </c:when>
              <c:otherwise>                          <c:set var="CHANNELValues" value="${fn:substring(CHANNELValues,2,fn:length(CHANNELValues))}"/> </c:otherwise>
   </c:choose>
   <c:choose> <c:when test="${empty AUTHENTICATIONValues}"> <c:set var="AUTHENTICATIONValues" value="<i>Not Relevant</i>"/> </c:when>
              <c:otherwise>                          <c:set var="AUTHENTICATIONValues" value="${fn:substring(AUTHENTICATIONValues,2,fn:length(AUTHENTICATIONValues))}"/> </c:otherwise>
   </c:choose>
   <c:choose> <c:when test="${empty CUSTOMERValues}"><c:set var="CUSTOMERValues" value="<i>Not Relevant</i>"/> </c:when>
              <c:otherwise>                          <c:set var="CUSTOMERValues" value="${fn:substring(CUSTOMERValues,2,fn:length(CUSTOMERValues))}"/> </c:otherwise>
   </c:choose>

   <c:set var="description">
     <c:choose>
        <c:when test="${empty r.description || fn:trim(r.description)==''}">${NONE}</c:when>
        <c:otherwise><c:out value='${r.description}'/></c:otherwise>
     </c:choose>
   </c:set>
   <c:set var="alertReason">
     <c:choose>
        <c:when test="${empty r.alertReason || fn:trim(r.alertReason)==''}">${NONE}</c:when>
        <c:otherwise><c:out value='${r.alertReason}'/></c:otherwise>
     </c:choose>
   </c:set>
   <c:set var="alertType">
     <c:choose>
        <c:when test="${empty r.alertTypeCode || r.alertTypeCode==' '}">${NONE}</c:when>
        <c:otherwise><c:out value='${alertTypeMap[r.alertTypeCode].desc} (${r.alertTypeCode})'/></c:otherwise>
     </c:choose>
   </c:set>
   <c:set var="executionOrderInfo">
     <c:choose>
       <c:when test="${empty r.executionOrderType}">
          ${NONE}
       </c:when>
       <c:when test="${-1 == r.executionOrderType}">
          Pre-Rule (priority order) Priority ${r.executionOrderPriority}
       </c:when>
       <c:when test="${0 == r.executionOrderType}">
         Main-Rule (dependency ordered)
       </c:when>
       <c:when test="${1 == r.executionOrderType}">
          Post-Rule (priority order) Priority ${r.executionOrderPriority}
       </c:when>
       <c:otherwise>
         Execution order type #${r.executionOrderType} Priority ${r.executionOrderPriority}
       </c:otherwise>
     </c:choose>
   </c:set>
   <c:set var="preRequisitesForDisplay">
     <c:choose>
        <c:when test="${empty r.ruleDependencies}"></c:when>
        <c:when test="${r.workflowState!='Coding' && r.workflowState!='Testing' && r.workflowState!='Production'}">
           <c:set var='sep' value=' '/>
           <c:forEach var="d" items="${r.ruleDependencies}">${sep}${d.baseRuleId}<c:set var='sep' value=', '/></c:forEach>
        </c:when>
        <c:otherwise>
           <c:set var='sep' value=' '/>
           <c:forEach var="d" items="${r.ruleDependencies}">${sep}#${fn:substring(depRulesMap[d.baseRuleId].ruleType,0,1)}${d.baseRuleId}: ${fn:escapeXml(depRulesMap[d.baseRuleId].name)} - ${depRulesMap[d.baseRuleId].workflowState} <i>(for %HasRuleFired)</i> <c:set var='sep' value='<br>'/></c:forEach>  <%-- S0881932 --%>
        </c:otherwise>
     </c:choose>
   </c:set>
   <c:set var="dependencySeparator">
     <c:choose>
       <c:when test="${not empty r && not empty r.weakDependencies && not empty r.ruleDependencies }"><br></c:when>
       <c:when test="${    empty r ||(    empty r.weakDependencies &&     empty r.ruleDependencies)}"><span class="softNone">None</span></c:when>
       <c:otherwise> </c:otherwise>
     </c:choose>
   </c:set>
   <c:set var="weakRequisitesForDisplay">
     <tiles:insert page="tiles/weakDependency.jsp" flush="false">
       <tiles:put name="rule" beanName="r" />
       <tiles:put name="none" value="" />
     </tiles:insert>
   </c:set>
   <c:set var="usedVariablesForDisplay">
     <c:choose>
        <c:when test="${empty r.usedVariableList}">${NONE}</c:when>
        <c:otherwise>
           <c:set var='sep' value=''/>
           <c:forEach var="v" items="${r.usedVariableList}">${sep} ${fn:toUpperCase(fieldNameMap[v.variableId])}<c:set var='sep' value=','/></c:forEach>
        </c:otherwise>
     </c:choose>
   </c:set>
   <c:set var="code">
     <c:choose>
        <c:when test="${empty r.code}">${NONE}</c:when>
        <c:otherwise>${fn:escapeXml(r.code)}</c:otherwise>  <%-- S0881932 --%>
     </c:choose>
   </c:set>


   <%-- Include common print layout (used here as well as from rule code editor) --%>
   <%@ include file="/rules/tiles/printRule.jsp" %>


</c:forEach>


</BODY>
</HTML>


