
//Update the lookup list registration (only description at the moment)
function updateLookupListDefinition()
{
   var name = document.getElementById("name").innerHTML.replace(/^\s*|\s*$/g,""); // Trim whitespace
   var inds = document.getElementById("inds").innerHTML.replace(/^\s*|\s*$/g,""); // Trim whitespace
   var desc = document.getElementById("desc").value.replace(/^\s*|\s*$/g,"");
   if (isLookupListFromForeignBusinessUnit(lookupListId, name, "updated"))
     return;     
   var target = lookupListAction + '?method=updateLookupListDefinition' +
        '&name=' + encodeURIComponent(name) +
        '&desc=' + encodeURIComponent(desc) +
        '&inds=' + encodeURIComponent(inds) +
        '&lookupListId=' + lookupListId +
        '&lookupListUpNbr=' + lookupListUpNbr +
        '&engine=' + engine;
   setBusyDetail();
   //parent.frames[ "detail" ].location.href = target;
   $df.postURL( "detail", target);
}


//Delete lookup lists selected from list
function deleteLookupLists()
{
// Setup multiple selections
setSelectedLookupLists();
if (selectedLookupListIds.length == 0)
{
      alert("One or more selections must be made before this request can be processed.");
      return;
}
for (var i=0; i<selectedLookupListIds.split(',').length; i++) {
    if (isLookupListFromForeignBusinessUnit(selectedLookupListIds.split(',')[i], selectedLookupListNames.split(',')[i], "deleted"))
     return;     
}
var deleteOrUnregister;
if (selectedLookupListNames=="" || selectedLookupListNames.match(/^,*$/))
{
   deleteOrUnregister = 'delete';
   if (!confirm("OK to delete the selected content files?"))
       return;
}
else
{
   deleteOrUnregister = window.showModalDialog(lookupListDeleteAction, window, "dialogHeight:190px;dialogWidth:450px;resizable:1;scroll:0;status:0;help:0;");
   if (!deleteOrUnregister)
      return;
}

var target = lookupListAction + '?method=deleteLookupLists' +
                          '&idList=' + selectedLookupListIds +
                          '&nbrList=' + selectedLookupListUpNbrs +
                          '&nameList=' + selectedLookupListNames +
                          '&indsList=' + selectedLookupListFiles +
                          '&contentOrList=' + contentOrList +
                          '&deleteOrUnregister=' + deleteOrUnregister +
                          '&engine=' + engine;
//parent.frames[ "detail" ].location.href = target;
$df.postURL( "detail", target);
}

//Persist the new lookup list displayed
function saveLookupListDefinition()
{
  var name = document.getElementById("name").value.replace(/^\s*|\s*$/g,""); // Trim whitespace
  var desc = document.getElementById("desc").value.replace(/^\s*|\s*$/g,"");
  var tag = document.getElementById("inds");
  var inds = tag.options[tag.selectedIndex].value;

  var columnTags = document.getElementById("columntags").getElementsByTagName("INPUT")
  var columnAry = new Array();
  var gotKey = false;
  for (var ct=0; ct<columnTags.length; ct++) {
      var columnTag = columnTags[ct];
      if (columnTag.checked) {
          columnAry.push(columnTag.id.substr(3));
          gotKey = true;
      }
      else
          columnAry.push(columnTag.id.substr(3) + "@");
  }
  if (columnAry.length==0) {
      alert("The selected content file must have at least one column");
      return;
  }
  var columns = columnAry.join(" ");
  if (!gotKey) {
      alert("At least one key column must be selected");
      return;
  }
  var target = lookupListAction + '?method=createLookupList' +
               '&contentOrList=' + contentOrList +
               '&name=' + encodeURIComponent(name) +
               '&desc=' + encodeURIComponent(desc) +
               '&inds=' + encodeURIComponent(inds) +
               '&columns=' + encodeURIComponent(columns) +
               '&engine=' + encodeURIComponent(engine);

  setBusyDetail();
  //parent.frames[ "detail" ].location.href = target;
  $df.postURL( "detail", target);
}

// If this lookup list is from a non-matching business unit, we may not view, edit, or otherwise access it
function isLookupListFromForeignBusinessUnit(id, name, operation) {
    if (lookupListIdsFromForeignBusinessUnits[id] == true) {
        alert("Lookup list '" + name + "' is from a different business unit than the currently selected business unit and so may not be " + operation);
        return true;
    }
    return false;
}

