// for single select
var selectedLookupListId = '';
var selectedLookupListUpNbr = '';
var selectedLookupListName = '';
var selectedLookupListFile = '';
// for multi select
var selectedLookupListIds = '';
var selectedLookupListUpNbrs = '';
var selectedLookupListNames = '';
var selectedLookupListFiles = '';

//refresh LookupListContents
function refreshContents(action)
{
   parent.frames[ "overview" ].location.href = action + '?method=uploadExistingLookupListContentsFile' + '&refresh=true';
}

// Display list of lookup lists based on overview selection (all/age/ose)
function showLookupLists(action,engine)
{
  var method = '?method=listLookupLists';
  var target;
  if (engine)
     target = action + method + '&engine=' + engine.split("_")[0];
  else
  {
     selectedNodes = _lookupListsTree.getSelectedNodes();
     var sel = selectedNodes[0].getId().split("_");
     engine = sel[0];
     var contentOrList = (sel[1]) ? sel[1] : "list";
     target = action + method + '&engine=' + engine + "&contentOrList=" + contentOrList;
  }
  parent.frames[ "detail" ].location.href = target;
}

// View lookup list selected from list
function viewLookupList()
{
    setSelectedLookupLists();
    if (selectedLookupListId == '')
    {
       alert(" A single selection must be made to process this request");
       return;
    }
   _viewLookupList(selectedLookupListId, selectedLookupListUpNbr, selectedLookupListName, selectedLookupListFile);
}
function _viewLookupList(selectedLookupListId, selectedLookupListUpNbr, selectedLookupListName, selectedLookupListFile)
{
    if (selectedLookupListId == '')
    {
       alert(" A single selection must be made to process this request");
       return;
    }
    if (isLookupListFromForeignBusinessUnit(selectedLookupListId, selectedLookupListName, "viewed"))
      return;         
    var target = lookupListAction + '?method=viewLookupList' +
                 '&lookupListId=' + selectedLookupListId +
                 '&lookupListName=' + selectedLookupListName +
                 '&lookupListInds=' + selectedLookupListFile +
                 '&contentOrList=' + contentOrList +
                 '&engine=' + engine;
    setBusyDetail();
    parent.frames[ "detail" ].location.href = target;
}

//Display screen to create a new lookup list
function newLookupList()
{
  var target = lookupListAction + '?method=newLookupList&engine=' + engine + "&contentOrList=" + contentOrList;
  setBusyDetail();
  parent.frames[ "detail" ].location.href = target;
}

// Display screen to register a lookup list
function registerContentFile()
{
   // Setup multiple selections
   setSelectedLookupLists();
   var target = lookupListAction + '?method=newLookupList&engine=' + engine + "&inds=" + selectedLookupListFile + "&contentOrList=" + contentOrList;
   setBusyDetail();
   parent.frames[ "detail" ].location.href = target;
}

// Cancel out of an upload request for a new file
function cancelNewFileUploadRequest()
{
  document.getElementById("inds").style.display = "";
  document.getElementById("uploadForm").style.display = "none";
  return;
}

// Display contents of a lookup list (first page only - next pages come from form in lookupListContents.jsp)
function showLookupListContents(engine,name,inds,columns,firstRow,viewFrame)
{
  var selector = document.getElementById("inds");

  // Question mark means user selected "Upload new lookup list contents"
  if (inds=='?')
  {
     var returnValue = window.showModalDialog(lookupListUploadAction+'&method=uploadNewLookupListContentsFile&target=lookupListContentsFrame', window, "dialogHeight:160px;dialogWidth:420px;resizable:1;scroll:0;status:0;help:0;");
     if (returnValue)
     {
        var slen = selector.options.length;
        for (var i=0; i<slen; i++)
        {
           if (selector.options[i].value==returnValue)
           {
              selector.selectedIndex = 0;
              return;
           }
        }
        selector.selectedIndex = 0;
     }
     else
        selector.selectedIndex = 0;
  }
  // Non-question mark non-blank means user selected a contents file
  else if (inds != '')
  {
     var msg = getIndsBadFileNameMessage(inds);
     if (msg)
     {
        alert(msg);
        if (selector)
            selector.selectedIndex = 0;
        document.frames[ viewFrame ].location.href = "rules/beige.htm";
     }
     else
     {
        var method = '?method=showLookupListContents';
        var query = '&engine=' + engine + "&name=" + encodeURIComponent(name) + "&inds=" + encodeURIComponent(inds) + "&columns=" + encodeURIComponent(columns) + "&firstRow=" + firstRow;
        document.frames[ viewFrame ].location.href = lookupListAction + method + query;
     }
  }
}


// Download content file
function downloadContentFile()
{
   // Setup multiple selections
   setSelectedLookupLists();
   if (selectedLookupListFile=='')
   {
      alert("Exactly one file must be selected to download.");
      return;
   }
   if (isLookupListFromForeignBusinessUnit(selectedLookupListId, selectedLookupListName, "downloaded"))
      return;     
   var target = lookupListAction + "?method=downloadContentFile&engine=" + engine + "&contentOrList=" + contentOrList + "&inds=" + encodeURIComponent(selectedLookupListFile);
   document.frames[ "downloadFrame" ].location.href = target;
}

// Upload content file
function uploadContentFile()
{
   // Setup multiple selections
   setSelectedLookupLists();
   if (selectedLookupListFile=='')
   {
      alert("Exactly one file must be selected to upload.");
      return;
   }
   if (isLookupListFromForeignBusinessUnit(selectedLookupListId, selectedLookupListName, "uploaded"))
      return;     
   var returnValue = window.showModalDialog(lookupListUploadAction+'&method=uploadExistingLookupListContentsFile&contentOrList=' + contentOrList + '&target=detail&inds='+selectedLookupListFile, window, "dialogHeight:160px;dialogWidth:420px;resizable:1;scroll:0;status:0;help:0;");
}


// Display the list of lookup lists for the indicated engine
function reshowLookupLists(newContentOrList, newEngine)
{
  engine = (newEngine) ? newEngine : engine;
  contentOrList = (newContentOrList) ? newContentOrList : contentOrList;
  var method = '?method=listLookupLists';
  var target = lookupListAction + method + '&engine=' + engine + "&contentOrList=" + contentOrList;
  parent.frames[ "detail" ].location.href = target;
}

// Edit the lookup list selected from list
function editLookupList()
{
    setSelectedLookupLists();
    if (selectedLookupListId == '')
    {
       alert(" A single lookup list must be selected to process this request.");
       return;
    }
   _editLookupList(selectedLookupListId);
}

// Update the indicated lookup list
function _editLookupList(selectedLookupListId)
{
    if (selectedLookupListId == '')
    {
       alert(" A single lookup list must be selected to process this request.");
       return;
    }
    if (selectedLookupListId < 0)
    {
        alert("Lookup list content files cannot be edited.");
        return;
    }
    if (isLookupListFromForeignBusinessUnit(selectedLookupListId, selectedLookupListName, "edited"))
      return;     
    target = lookupListAction + '?method=viewLookupList' +
             '&update=1' +
             '&contentOrList=' + contentOrList +
             '&lookupListId=' + selectedLookupListId +
             '&engine=' + engine;
    setBusyDetail();
    parent.frames[ "detail" ].location.href = target;
}

function handleRowSelectionLookupList(id, upnbr, name, inds, row, className, event)
{
   var lookupList = new Object();
   lookupList.id = id;
   lookupList.upnbr = upnbr;
   lookupList.name = name;
   lookupList.inds = inds;
   highlightRow(row, className, event, lookupList);
}

var selectedRule;
function handleRowSelectionRule(id, upnbr, state, row, className, event)
{
   var rule = new Object();
   rule.id = id;
   rule.upnbr = upnbr;
   rule.state = state;
   selectedRule = rule;
   var trs = document.getElementById("ruleTableBody").getElementsByTagName("TR");
   for (var i=0; i<trs.length;i++)
   {
      var tds = trs[i].getElementsByTagName("TD");
      for (var j=0; j<tds.length;j++)
      {
         if (i % 2 == 0)
            tds[j].style.backgroundColor = 'white';
         else
            tds[j].style.backgroundColor = '#FAF8ED';
      }
   }
   var tds = row.getElementsByTagName("TD");
   for (var i=0; i<tds.length;i++)
   {
      tds[i].style.backgroundColor = '#ddddee';
   }
}

function _setSelectedLookupList(id, upnbr, name, inds)
{
   selectedLookupListId = id;
   selectedLookupListUpNbr = upnbr;
   selectedLookupListName = encodeURIComponent(name);
   selectedLookupListFile = encodeURIComponent(inds);
}

function setSelectedLookupLists()
{
     selectedLookupListId = ''
     selectedLookupListUpNbr = '';
     selectedLookupListName = '';
     selectedLookupListFile = '';
     selectedLookupListIds = ''
     selectedLookupListUpNbrs = '';
     selectedLookupListNames = '';
     selectedLookupListFiles = '';

     // iterate through keys in hashmap
     for(var i in _highlightedRowMap)
     {
         var selection = _highlightedRowMap[i];
         if (selection != null && isDefined(selection))
         {
           var lookupList = selection.mappedObject;
           selectedLookupListIds += lookupList.id + ",";
           selectedLookupListUpNbrs += lookupList.upnbr + ",";
           selectedLookupListNames += (lookupList.id>0 ? encodeURIComponent(lookupList.name.replace(/^\s*|\s*$/g,"")) : "") + ",";
           selectedLookupListFiles += encodeURIComponent(lookupList.inds.replace(/^\s*|\s*$/g,"")) + ",";
         }
     }

     // trim out the extra ',' for multi select
     if (selectedLookupListIds.length > 0)
        selectedLookupListIds = selectedLookupListIds.substring(0, selectedLookupListIds.length -1);
     if (selectedLookupListUpNbrs.length > 0)
        selectedLookupListUpNbrs = selectedLookupListUpNbrs.substring(0, selectedLookupListUpNbrs.length -1);
     if (selectedLookupListNames.length > 0)
        selectedLookupListNames = selectedLookupListNames.substring(0, selectedLookupListNames.length -1);
     if (selectedLookupListFiles.length > 0)
        selectedLookupListFiles = selectedLookupListFiles.substring(0, selectedLookupListFiles.length -1);

     // for single select
     var list = selectedLookupListIds.split(',');
     if (list.length == 1)
     {
       selectedLookupListId = selectedLookupListIds;
       selectedLookupListUpNbr = selectedLookupListUpNbrs;
       selectedLookupListName = selectedLookupListNames;
       selectedLookupListFile = selectedLookupListFiles;
     }
}


// Returns a message if file name is not valid for a content file
function getIndsBadFileNameMessage(inds)
{
  // These patterns also appear in RulesServiceImpl.java
  if (!inds || inds.replace(/^\s*|\s*$/g,"")=='')
     return "A lookup list contents file name was not specified but is required.";
//  if (!inds.match("^[\\.a-zA-Z0-9_\\- ]{1,60}\\.csv$") && !inds.match("^[a-zA-Z_]\\w{0,31}\\.sas7bdat$"))
//     return "File name \"" + inds + "\" is not a valid .csv or .sas7bdat file name.\n\n" +
//            "Lookup list content file names must be either a valid SAS dataset name ending with .sas7bdat or\n" +
//            "a .csv file of 1-64 letters, numbers, underscores, hyphens, blanks, or dots.";
}


// Displays rule details in a form suitable for printing
function showPrintableRule(action,id,upnbr,state)
{
   if (!id)
   {
      if (!selectedRule)
      {
         alert(" A selection must be made to process this request.");
         return;
      }
      id = selectedRule.id;
      upnbr = selectedRule.upnbr;
      state = selectedRule.state;
   }
   var link = action + "?method=printRules&idList=" + id + "&lockVersionList=" + upnbr + "&workflow=" + state + "&destWorkflow=" + state + "&userId=";
   var w = window.open(link,'PrintableRule'+new Date().valueOf(),'menubar,toolbar,resizable=1, scrollbars=1, status=1, width=700, height=550');
   w.focus();
}


