// for single select
var selectedRuleId = '';
var selectedBaseRuleId = '';
var selectedRuleName = '';
var selectedRuleVersion = '';
var selectedRuleLockVersion = '';
var selectedRuleState = '';

// for multi select
var selectedRuleIds = '';
var selectedBaseRuleIds = '';
var selectedRuleNames = '';
var selectedRuleVersions = '';
var selectedRuleLockVersions = '';
var selectedRuleStates = '';

function setSelectedRules()
{
    var selectedRuleIdList= new Array();
    var selectedBaseRuleIdList= new Array();
    var selectedRuleNameList= new Array();
    var selectedRuleVersionList= new Array();
    var selectedRuleLockVersionList= new Array();
    var selectedRuleStateList= new Array();

    selectedRuleId = '';
    selectedBaseRuleId = '';
    selectedRuleName = '';
    selectedRuleVersion = '';
    selectedRuleLockVersion = '';
    selectedRuleState = '';

    // alert("setSelectedRules");

    // iterate through keys in hashmap
    for(var i in _highlightedRowMap)
    {
        var selection = _highlightedRowMap[i];
        if(selection != null && isDefined(selection))
        {
          var rule = selection.mappedObject;
          var p = rule.position;
          selectedRuleIdList[p] = rule.id;
          selectedBaseRuleIdList[p] = rule.baseRuleId;
          selectedRuleNameList[p] = rule.name;
          selectedRuleVersionList[p] = rule.version;
          selectedRuleLockVersionList[p] = rule.lockVersion;
          selectedRuleStateList[p] = rule.state;
        }
    }

    // Assign values in their displayed order (trim multi, leading, and trailing commas)
    selectedRuleIds = selectedRuleIdList.join(",").replace(/^,*|,*$/g,"").replace(/,+/g,",");
    selectedBaseRuleIds = selectedBaseRuleIdList.join(",").replace(/^,*|,*$/g,"").replace(/,+/g,",");
    selectedRuleNames = selectedRuleNameList.join(",").replace(/^,*|,*$/g,"").replace(/,+/g,",");
    selectedRuleVersions = selectedRuleVersionList.join(",").replace(/^,*|,*$/g,"").replace(/,+/g,",");
    selectedRuleLockVersions = selectedRuleLockVersionList.join(",").replace(/^,*|,*$/g,"").replace(/,+/g,",");
    selectedRuleStates = selectedRuleStateList.join(",").replace(/^,*|,*$/g,"").replace(/,+/g,",");

    // Show single selection if only one selected
    if (selectedRuleIds.split(',').length == 1)
    {
      selectedRuleId = selectedRuleIds.split(',')[0];
      selectedBaseRuleId = selectedBaseRuleIds.split(',')[0];
      selectedRuleName = selectedRuleNames.split(',')[0];
      selectedRuleVersion = selectedRuleVersions.split(',')[0];
      selectedRuleLockVersion = selectedRuleLockVersions.split(',')[0];
      selectedRuleState = selectedRuleStates.split(',')[0];
   }

}

//variables to store values updated by model dialog
var fromEmailAddress = '';
var emailList = '';
var userNotes = '';

//optional: destWorkflow, newWindow, srcWorkflow)
function processMultiSelectRequest(method, destWorkflow, newWindow, srcWorkflow)
{// debugger;
   setSelectedRules();
   if(selectedRuleIds.length == 0)
   {
      alert("One or more rules must be selected before this request can be processed");
      return;
   }
   // escape # character
   selectedRuleNames = selectedRuleNames.replace(/#/g, '%23').replace(/%/g, '%25');

   var theAction = '';
   if(method == 'createEstimate')
      theAction = estimateAction;
   else
      theAction = action;

   if (!window.userId)
      userId = "";

   // TODO: Use POST of form fields instead of a GET with a URL
   link = theAction + "?method=" + method + "&idList=" + selectedRuleIds +
                 "&lockVersionList=" + selectedRuleLockVersions +
                 "&destWorkflow=" + destWorkflow + "&userId=" + userId;

   if (workflow=='Estimations')
      link += "&workflow=" + (document.forms.estimateForm.excludeTestingRules.checked ? "Production" : "Testing");
   else
      link += "&workflow=" + selectedRuleStates.split(",")[0];
   selectedRuleIds = '';
   if(method == 'processStateTransition')
   {
      link += "&fromEmailAddress=" + fromEmailAddress;
      link += "&emailList=" + emailList;
      link += "&userNotes=" + userNotes;
      if (srcWorkflow=="Production"){
      } else {
          if (destWorkflow=="Production" && hasUnacceptableStates("Testing", "transition to Production")) return;
          else if (destWorkflow=="Coding"      && hasUnacceptableStates("Testing", "move to Coding")) return;
          else if (destWorkflow=="Deactivated" && hasUnacceptableStates("Production","be deactivated")) return;    	  
      }       
   }
   if(method == 'createEstimate')
   {
      var estName = trim(document.getElementById("estimateName").value);
      if (estName.length>50 && estName.substring(0,5)=='DEBUG') {
          alert("Addition of required DEBUG prefix to estimation name has made it longer than 50 characters.  " +
                "Shorten the name by " + (estName.length-50) + " characters and try again.");
          return;
      }
      link += "&estimateName=" + encodeURIComponent(estName);
      link += "&estimationCreationDatetimes=" + document.getElementById("estimationCreationDatetimes").value;
      if (document.getElementById("noRecontactBox").checked) {
         var nrdays = trim(document.getElementById("noRecontactDays").value);
         if (!nrdays.match(/^\d+$/))
             nrdays = -1;
         else {
            try { nrdays = parseInt(nrdays); }
            catch (e) { nrdays = -1; }
         }
         if (nrdays=='' || nrdays < 1 || nrdays > 2147483647) {
             alert('No-Recontact days=' + document.getElementById("noRecontactDays").value + ' which is not an integer between 1 and 2147483647, inclusive');
             return;
         }
         link += "&noRecontactDays=" + encodeURIComponent(trim(document.getElementById("noRecontactDays").value));
      }
      else
         link += "&noRecontactDays=0";
      link += "&dampenFirings=" + document.getElementById("dampenFirings").checked;
      link += "&reportTotalCounts=" + document.getElementById("reportTotalCounts").checked;
      link += "&cacheUserVars=" + document.getElementById("cacheUserVars").checked;
      link += "&sortInSas=" + document.getElementById("sortInSas").checked;

      var splitTransactions = document.getElementById("splitTransactions").checked;
      link += "&splitTransactions=" + splitTransactions;
      var sampPct = getValidSamplePercent(document.getElementById("samplePercent"));
      var multiThreading = document.getElementById("useMultiThreading").checked;
      if (splitTransactions) {
         var sampKey = document.getElementById("sampleKey"); 
         link += "&sampleKey=" + sampKey.options[sampKey.selectedIndex].value; 
            
         if (!sampPct)
             return;
         link += "&samplePercent=" + sampPct; 
            
         var sampBktStr = document.getElementById("sampleBucket").value; 
         var sampBkt; 
         var sampBktLimit = Math.ceil(100/sampPct);
         try { sampBkt = parseInt(sampBktStr); } 
         catch (e) { sampBkt = -1; } 
         if (!sampBkt || sampBkt <= 0 || sampBkt > sampBktLimit || sampBktStr.indexOf(".")>=0)  
         {
             alert("Sample bucket number " + sampBktStr + " is not a whole number between 1 and " + sampBktLimit + ", inclusive"); 
             return; 
         }
         link += "&sampleBucket=" + sampBkt;

         var sampThd;          
         if (multiThreading) {
            var sampThdStr = document.getElementById("sampleThreads").value; 
            var sampThdMax = document.getElementById("estimationMaxThreadCount") ? document.getElementById("estimationMaxThreadCount").value : 1;
            sampThdLimit = Math.min(sampThdMax, Math.floor(10*sampPct));
            try { sampThd = parseInt(sampThdStr); } 
            catch (e) { sampThd = -1; } 
            if (!sampThd || sampThd < 1 || sampThd > sampThdLimit || sampThdStr.indexOf(".")>=0)  
            {
                alert("Thread count " + sampThdStr + " is not a whole number between 1 and " + sampThdLimit +
                      ", inclusive (absolute max threads=" + sampThdMax + ")"); 
                return; 
            }
         }
         else
             sampThd = 1;
         link += "&sampleThreads=" + sampThd;         
      }
      else {
         if (sampPct && sampPct != 100) {
             alert('Sampling ' + sampPct + '% of transactions is invalid when "Split Transactions" is not checked');
             return;
         }
         if (multiThreading) {
             alert('Parallel processing with multiple threads is invalid when "Split Transactions" is not checked');
             return;
         }
      }

      link += "&filterAccount=" + encodeURIComponent(document.getElementById("filterAccount").value);
      if (document.getElementById("reportRedistributableAlerts"))
      {
          var isRedist = document.getElementById("reportRedistributableAlerts").checked;
          if (isRedist && selectedRuleStates.indexOf('Testing')>=0) {
            alert("Redistribution is not valid with Testing rules");
            return;
          }
          link += "&reportRedistributableAlerts=" + isRedist;
      }
      var tags = document.getElementsByTagName("INPUT");
      for (var t in tags)
      {
         if (tags[t].id && tags[t].id.substr(0,9)=='reportPer')
            link += "&" + tags[t].id + "=" + tags[t].checked;
      }
   }

   if(method == 'deleteRules')
   {
      if(!confirm("Are you sure you want to delete the selected rules?"))
        return;
   }

   // Send the request to a new window (if so requested and not already open)
   if (newWindow)
   {
         theWindow = openRuleDetailWindow( link, selectedRuleId );
   }
   else if (method == 'printRules')
   {
     var printWindowName = 'PrintableRule'+new Date().valueOf(); 
     var w = window.open('common/blank.html',
                         printWindowName,
                         'menubar,toolbar,resizable=1, scrollbars=1, status=1, width=800, height=600');
     $df.postURL(printWindowName, link);
     w.focus();           
   }
   else
   {
      if(method != 'exportRules')
         setBusyDetail();
      //parent.frames[ "detail" ].location.href = link;
	  $df.postURL("detail", link);
   }

}


// Invokes a detail view of the previously-established rule (optional: destWorkflow, newWindow)
function processRequest(method, destWorkflow, newWindow)
{
   setSelectedRules();
   if (selectedRuleId == '')
   {
      alert("A single rule must be selected before this action can be processed");
      return;
   }
   if (method == 'createVersion' && destWorkflow=="Coding" && hasUnacceptableStates("Production Deactivated Trash Archive","be used to create a new version")) return;

   if(method == 'deleteRule')
   {
      if(!confirm("Are you sure you want to delete the selected rule?"))
        return;
   }
   // escape # character
   selectedRuleName = selectedRuleName.replace(/#/g, '%23').replace(/%/g, '%25');

   var link = action + "?method=" + method + "&id=" + selectedRuleId + "&baseRuleId=" + selectedBaseRuleId +
              "&version=" + selectedRuleVersion + "&name=" + selectedRuleName +
              "&lockVersion=" + selectedRuleLockVersion + "&workflow=" + selectedRuleState
              + "&destWorkflow=" + destWorkflow;

   // testing remove before pushing
  link += "&testing=true";

   // Send the request to a new window (if so requested and not already open)
   if (newWindow)
      theWindow = openRuleDetailWindow( link, selectedRuleId );
   else
   {
     // alert(link);
     setBusyDetail();
     // parent.frames[ "detail" ].location.href = link;
	 $df.postURL("detail", link);
   }
}

function emptyTrash()
{
   if(!confirm("Are you sure you want to delete all rules from trash?"))
        return;
   var link = action + "?method=emptyTrash";
   setBusyDetail();
   // parent.frames[ "detail" ].location.href = link;
   $df.postURL("detail", link);
}

//Opens rule detail in a separate, possibly new window (optional:id (for existing rule))
function openRuleDetailWindow(link, id)
{
   top.ruleWindowCache = (top.ruleWindowCache) ? top.ruleWindowCache : new Array();
   var theWindowName;
   var theWindow;
   if (id)
   {
      theWindowName = 'rule_detail_window_' + id;
      theWindow = top.ruleWindowCache[ theWindowName ];
   }
   else
   {
      var dt = new Date();
      var guid = dt.getHours()*3600000 + dt.getMinutes()*60000 + dt.getSeconds()*1000 + dt.getMilliseconds();
      theWindowName = 'rule_detail_window_' + guid;
   }

   if (!theWindow || theWindow.closed)
   {
     var popH = getCookie("rule_detail_window_height");
     var popW = getCookie("rule_detail_window_width");
     if (!popH || !popW)
     {
       popW = (top.innerWidth)  ? (top.innerWidth-30)  : (top.document.body.offsetWidth-30);
       popH = (top.innerHeight) ? (top.innerHeight-30) : (top.document.body.offsetHeight-50);
       popW = 725;
       popH = 600;
     }
     var popOff = getCookie("rule_detail_window_offset");
     if (!popOff || popOff > 125)
       popOff = 25;
     else
       popOff = parseInt(popOff) + 25;
     var theDate = new Date();
     theDate.setYear(theDate.getYear() + 100);
     setCookie("rule_detail_window_offset", popOff, theDate);
     theWindow = window.open('common/blank.html', theWindowName,
             'resizable=1,scrollbars=1,status=1,width=' + popW + ',height=' + popH + ',left=' + (parent.screenLeft+popOff) + ',top=' + (parent.screenTop + popOff));
     $df.postURL(theWindowName, link);
     top.ruleWindowCache[ theWindowName ] = theWindow;
   }
   theWindow.focus();
   return theWindow;
}

function showRequestApprovalPopup(workflow, msg, buId)
{ // debugger; 
   setSelectedRules();
   if(selectedRuleIds.length == 0)
   {
      alert("One or more rules must be selected before this request can be processed");
      return;
   }
   if (hasUnacceptableStates(workflow, msg)) return;

   // Initiates a request to fetch data for the request approval window
   var url = action + "?method=" +"requestApproval" + "&businessUnitId=" + buId ;
   rval = window.showModalDialog(url, window, "dialogHeight:410px;dialogWidth:460px;resizable:1;scroll:1;status:1;help:0;")
   // alert("control back to main window, rval: " + rval);
   if(rval == 1)
   {
      processMultiSelectRequest('processStateTransition', workflow, '', 'Production');	// method, destWorkflow, newWindow, srcWorkflow
   }
   else
   {
      return;
   }

}

//Validates then submits a request to execute an estimation
function runEstimation(debug, validate)
{
   if (noLandlordEstimation) {
      alert("Creating a estimation using business unit '" + estimationBusinessUnitName + "' is not supported.  Select a tenant-level business unit instead.");
      return;
   }
    
   if (validate && document.getElementById('estimateName').value.indexOf('VALEST')<0)
      document.getElementById('estimateName').value += ' VALEST';

   var acct = document.getElementById("filterAccount").value;
   if (acct!=acct.replace(/[^a-zA-Z0-9\-=\.\+_%\$#@!&\*|:;<>,\?/]/,''))
   {
      alert("Please remove invalid characters from the account filter (account filter may contain only letters, numbers, hyphen, equals sign, dot, plus, underscore, percent, dollar, hash, at sign, exclamation point, ampersand, asterisk, or-bar, colon, semi-colon, less than sign, greater than sign, comma, question mark, and slash).");
      return false;
   }

   var startDateValue = trim(document.getElementById('startMonth').value)  + "/" +
                        trim(document.getElementById('startDay').value)    + "/" +
                        trim(document.getElementById('startYear').value)   ;
   var startTimeValue = trim(document.getElementById('startHour').value)   + ":" +
                        trim(document.getElementById('startMinute').value) + ":" +
                        trim(document.getElementById('startSecond').value) ;
   var endDateValue = trim(document.getElementById('endMonth').value)  + "/" +
                      trim(document.getElementById('endDay').value)    + "/" +
                      trim(document.getElementById('endYear').value)   ;
   var endTimeValue = trim(document.getElementById('endHour').value)   + ":" +
                      trim(document.getElementById('endMinute').value) + ":" +
                      trim(document.getElementById('endSecond').value) ;
   if (startDateValue == '//')
       startDateValue = '';
   if (startTimeValue == '::')
       startTimeValue = '';
   if (endDateValue == '//')
       endDateValue = '';
   if (endTimeValue == '::')
       endTimeValue = '';
   
   if (!isValidTimestampRange(startDateValue, startTimeValue, endDateValue, endTimeValue))
       return;
   
   // Remember datetimes
   var theDate = new Date();
   theDate.setYear(theDate.getYear() + 100);
   var estimationCreationDatetimes = startDateValue + " " + startTimeValue + " " + endDateValue + " " + endTimeValue;
   setCookie("estimation_creation_datetimes", estimationCreationDatetimes, theDate);
   document.getElementById("estimationCreationDatetimes").value = estimationCreationDatetimes;

   // Use DEBUG prefix if debugging
   var estName = document.getElementById("estimateName").value;
   if (debug && estName.toUpperCase().indexOf("DEBUG")!=0)
      document.getElementById("estimateName").value = "DEBUG: " + estName;
   else if (!debug && estName.toUpperCase().indexOf("DEBUG:")==0)
      document.getElementById("estimateName").value = estName.substr(6).replace(/^\s*|\s*$/g,"");
   // Submit request
   processMultiSelectRequest('createEstimate','');
   return;
}

// Validate date range for estimation and rule testing
function isValidTimestampRange(startDateValue, startTimeValue, endDateValue, endTimeValue)
{   
   if(startDateValue != '' && !isDate(startDateValue))
   {
      alert("The start date is not a valid start date. Please enter the start date as digits in the form:\n\n\tYear (4 digits)\n\tMonth (digits only, value 1-12)\n\tDay (digits only, value 1-31)");
      return false;
   }
   if(endDateValue != '' &&  !isDate(endDateValue))
   {
      alert("The end date is not a valid end date. Please enter the end date as digits in the form:\n\n\tYear (4 digits)\n\tMonth (digits only, value 1-12)\n\tDay (digits only, value 1-31)");
      return false;
   }
   if(startTimeValue != '' && !isTime(startTimeValue))
   {
      alert(startTimeValue + " is not a valid start time\n\nPlease enter the start time as:   \n\n    00:00:00 through 23:59:59");
      return false;
   }
   if(endTimeValue != '' && !isTime24(endTimeValue))
   {
      alert(endTimeValue + " is not a valid end time\n\nPlease enter the end time as:   \n\n    00:00:00 through 24:00:00");
      return false;
   }
   var sds = startDateValue + " " + startTimeValue;
   var eds = endDateValue   + " " + endTimeValue;
   try {
       var sd;
       if (startTimeValue=='24:00:00') {
           sd = new Date(startDateValue);
           sd = new Date(sd.getFullYear(), sd.getMonth(), sd.getDate()+1); 
       }
       else
           sd = new Date(sds);
       var ed;
       if (endTimeValue=='24:00:00') {
           ed = new Date(endDateValue);
           ed = new Date(ed.getFullYear(), ed.getMonth(), ed.getDate()+1); 
       }
       else
           ed = new Date(eds);
       if (!sd || isNaN(sd)) {
           alert("Start timestamp is invalid\nStart: " + sds + " resovles to " + sd);
           return false;
       }              
       if (!ed || isNaN(ed)) {
           alert("End timestamp is invalid\nEnd: " + eds + " resolves to " +ed);
           return false;
       }              
       if (sd >= ed) {
           alert("Start timestamp is later than or equal to the end timestamp\n" +
                 "\nStart:\t" + sds + " resolves to " + sd +
                 "\nEnd:\t"   + eds + " resolves to " + ed );
           return false;
       }
   } catch(e) {
       alert("Error parsing timestamps " + e + "\n" +
             "\nStart:\t" + sds + " resolves to " + sd +
             "\nEnd:\t"   + eds + " resolves to " + ed );
       return false;
   }
   return true;
}

//Creates an empty rule form for rule creation
function newRule(newWindow)
{
var link = action + "?method=createRule";
if (newWindow)
   openRuleDetailWindow( link );
else
   parent.frames[ "detail" ].location.href = link;
}


