---------------------------------------------------------------------------------
--
-- Update Transaction table names that were renamed
--
---------------------------------------------------------------------------------

UPDATE FRH_TRANSACTION_DEFINITION set SOR_TABLE_NAME='FCM_SLCP',RH_TABLE_NAME='FRH_SLCP' where SOR_TABLE_NAME='FCM_SLAP' OR SOR_TABLE_NAME='FRH_SLAP';
UPDATE FRH_TRANSACTION_DEFINITION set SOR_TABLE_NAME='FCM_SLCK',RH_TABLE_NAME='FRH_SLCP' where SOR_TABLE_NAME='FCM_SLAC' OR SOR_TABLE_NAME='FRH_SLAC';
---------------------------------------------------------------------------------

---------------------------------------------------------------------------------
--
-- Update Consortium Record Length
--
---------------------------------------------------------------------------------
update FRH_PROPERTY set 
	property_value='recfm=F lrecl=9160'
	,LSTUPDT_USER = CURRENT USER
	,LSTUPDT_TIMESTAMP = CURRENT TIMESTAMP
	,LSTUPDT_NBR = LSTUPDT_NBR+1
where property_name='CONSORT_FLOPT';

---------------------------------------------------------------------------------
--
-- Add new Property to have Consortium run recovery or not
--
---------------------------------------------------------------------------------
merge into FRH_PROPERTY
USING TABLE(values('CONSORT_SOR_CHECK'))
                     ac(PROPERTY_NAME) 
                  ON (FRH_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME)
when not matched then
insert (
	PROPERTY_NAME, PROPERTY_VALUE, PROPERTY_DESC, PROPERTY_LABEL, PROPERTY_TYPE, 
	CREATE_TIMESTAMP, CREATE_USER, LSTUPDT_USER, LSTUPDT_TIMESTAMP, LSTUPDT_NBR, LOGICAL_DEL_IND, 
	PROPERTY_EDITABLE_IND, PROPERTY_SUB_TYPE, PROPERTY_SUB_TYPE_LABEL) 
VALUES (
 'CONSORT_SOR_CHECK' 
 , 'N'
 , 'Check the SOR for missing records'
 , 'Consortium check SOR option'        
 , 'consort'
 ,  current timestamp - current timezone
 ,  CURRENT USER  
 ,  CURRENT USER  
 ,  current timestamp - current timezone
 , 0
 , '0'
 , '1'
 , 'DEFAULT'
 , 'DEFAULT')
ELSE IGNORE;


---------------------------------------------------------------------------------
--
-- Insert version release 3.3.1.5 (3.3 M1 HF5)
--
---------------------------------------------------------------------------------

insert into frh_version(VERSION_NAME , VERSION_NUM , VERSION_DATE , VERSION_DESC, VERSION_COMPONENT) VALUES
('Base DDL', '3.3.1.5', current date, '3.3 M1 HF5 DDL', 'DDL');