
CREATE OR REPLACE FUNCTION ELEMIDX ( STRING VARCHAR(10000) )
  RETURNS TABLE  (
    ORDINAL	INTEGER,
    INDEX	INTEGER,
    STRVAL	VARCHAR(10000) )
  SPECIFIC ELEMIDX
  LANGUAGE SQL
  DETERMINISTIC
  NO EXTERNAL ACTION
  CONTAINS SQL
  INHERIT SPECIAL REGISTERS
RETURN 
      WITH t(ordinal, index,strval) AS 
         ( VALUES ( 0, 0,'' ) 
           UNION ALL 
           SELECT ordinal+1,
                COALESCE(NULLIF(LOCATE(',', string, index+1), 0),LENGTH(string)+1),
                substr(string,index+1, LOCATE(',', string, index+1)-(index+1))
           FROM   t 
                  -- to prevent a warning condition for infinite 
                  -- recursions, we add the explicit upper 
                  -- boundary for the &quot;ordinal&quot; values 
           WHERE  ordinal < 10000 AND 
                  -- terminate if there are no further delimiters 
                  -- remaining 
                  LOCATE(',', string, index+1) <> 0 ) 
      SELECT ordinal, index,strval 
      FROM   t
@