CREATE OR REPLACE FUNCTION GET_RULE_SLOTS (I_BITS VARCHAR(3000) )
  RETURNS table(slot_id integer)
  SPECIFIC GET_RULE_SLOTS
  LANGUAGE SQL
  DETERMINISTIC
  NO EXTERNAL ACTION
  READS SQL DATA
-----------------------------------------------------------------------------
-- File:  GET_RULE_SLOTS
--
--
-- Description:  Decodes the RRF rule bit array
--
--
-- Called By:	webapp
--
--
-- Calls:
--
--
-- Notes:
--
--
-- Usage:
--
--
-- History:    2011/11/17:  Creation date
--
------------------------------------------------------------------------
F1: BEGIN ATOMIC
  DECLARE slots VARCHAR(32000) DEFAULT '';
  DECLARE ii INT DEFAULT 0;
  DECLARE ch CHAR(1);
  DECLARE start INT DEFAULT 0;
  DECLARE size INT;
  DECLARE chr_no integer;
  
  set size = length(i_bits);
  
    
  while(ii < size) do
     set ch = substr(upper(i_bits),ii+1,1);
     if(ch != '0') then 
         set chr_no=ascii(ch);
         set start = (ii * 4)+1;
        
        
        if(bitand(chr_no,8)=8) then
              set slots = rtrim(slots)|| rtrim(char(start)) || ',';
         end if;
         if(bitand(chr_no,4)=4) then
             set slots = rtrim(slots)|| rtrim(char(start+1)) || ',';
         end if;
         if(bitand(chr_no,2)=2) then
             set slots = rtrim(slots)|| rtrim(char(start+2)) || ',';
         end if;
         if(bitand(chr_no,1)=1) then
             set slots = rtrim(slots)|| rtrim(char(start+3)) || ',';
         end if;
        
     end if;
     set ii = ii + 1;
  end while;

  RETURN (select trim(strval)   from table(elemIdx(slots)) where length(trim(strval))>0);

END
@