---------------------------------------------------------------------------------
--
-- Update Transaction table names that were renamed. This will only update rows if there was 
-- a migration from 3.2M2. Otherwise Zero rows will be updated.
--
---------------------------------------------------------------------------------
UPDATE FCM_TRANSACTION_DEFINITION 
set SOR_TABLE_NAME='FCM_SLCP'
,RH_TABLE_NAME='FRH_SLCP'
,LSTUPDT_USER=CURRENT_USER
,LSTUPDT_TIMESTAMP= CURRENT_TIMESTAMP
where SOR_TABLE_NAME='FCM_SLAP' OR RH_TABLE_NAME='FRH_SLAP';

UPDATE FCM_TRANSACTION_DEFINITION 
set SOR_TABLE_NAME='FCM_SLCK'
,RH_TABLE_NAME='FRH_SLCP' 
,LSTUPDT_USER=CURRENT_USER
,LSTUPDT_TIMESTAMP= CURRENT_TIMESTAMP
where SOR_TABLE_NAME='FCM_SLAC' OR RH_TABLE_NAME='FRH_SLAC';


---------------------------------------------------------------------------------
--
-- Always make the VIEWGROUP and UPDTGROUP "ON" regardless if SAMS or XAMS
--
---------------------------------------------------------------------------------
UPDATE FCM_PRIVILEGE
SET LOGICAL_DEL_IND = 0
,LSTUPDT_USER=CURRENT_USER
,LSTUPDT_TIMESTAMP= CURRENT_TIMESTAMP
,LSTUPDT_NBR=LSTUPDT_NBR+1
WHERE SYSTEM_PRIVILEGE_NAME in ('VIEWGROUP', 'UPDTGROUP');
 
---------------------------------------------------------------------------------
--
-- If XAMS Configuration, set the XAMS Grids as NOT LOGICALLY DELETED.
-- If SAMS Configuration, the update will update Zero rows.
--
---------------------------------------------------------------------------------
UPDATE FCM_GRID_TMPLT 
SET LOGICAL_DEL_IND = 0
,LSTUPDT_USER=CURRENT_USER
,LSTUPDT_TIMESTAMP= CURRENT_TIMESTAMP
,LSTUPDT_NBR=LSTUPDT_NBR+1
WHERE
GRID_TEMPLATE_TYPE='XAMS'
AND exists(select PROPERTY_VALUE FROM FCM_PROPERTY where upper(property_name)=upper('webapp.enableXAMS') and upper(property_value)='TRUE');

---------------------------------------------------------------------------------
--
-- Insert version release 3.3.1.5 (3.3 M1 HF5)
--
---------------------------------------------------------------------------------

insert into fcm_version(VERSION_NAME , VERSION_NUM , VERSION_DATE , VERSION_DESC, VERSION_COMPONENT) VALUES
('Base DDL', '3.3.1.5', current date, '3.3 M1 HF5 DDL', 'DDL');