

CREATE OR REPLACE PROCEDURE ATTACH_PARTITION ( 
        i_tabname IN VARCHAR2,
        i_schema  IN VARCHAR2, 
        i_preview_only_ind IN VARCHAR2,
        o_sqlcode OUT NUMBER  )
-----------------------------------------------------------------------------
-- File:  ATTACH_PARTITION
--
--
-- Description:
--
--
-- Called By:
--
--
-- Calls:
--
--
-- Notes:     
-- 
--           
--
-- Usage:
--
--
-- History:    
--      2012/10/19   leushe   created       
--      2014/01/13   leushe   Modified to include ability to roll partitions on a monthly increment. (S1046549)  
--          
--         
--        
--     
--
------------------------------------------------------------------------

IS


   v_table_part_range    VARCHAR2(150);
   v_partition          VARCHAR2(50);
   v_dynStmt            VARCHAR2(1024);
   v_granularity        INTEGER;
   v_granularity_unit   VARCHAR2(10);



BEGIN






  --
  -- get the increment for the upper partition bound
  --
    
       select granularity into v_granularity
        from frx_partition_definition 
        where table_name = i_tabname 
     ;


  --
  -- get the granularity unit ( HOUR, DAY, MONTH )  for the upper partition bound
  --
    
       select granularity_unit into v_granularity_unit
        from frx_partition_definition 
        where table_name = i_tabname 
      ;

  --
  -- apply the correct granularity unit
  --
  -- NEED TO FIGURE THIS OUT
  IF ( v_granularity_unit = 'MONTH' ) THEN
--    v_granularity := v_granularity;
    --(v_timestamp + v_granularity MONTH) + 1 MONTH - day(v_timestamp + 1 MONTH) day;


 	select 'P'||to_char(to_number(substr(partition_name,2,
	         instr(partition_name,'_',1)-2))+1)||'_'||to_char(add_months(to_date((substr(partition_name,instr(partition_name,'_',1)+1,8)||'01'),'yyyy_mm_dd'),v_granularity),'yyyy_mm_dd')
	         ,'  VALUES LESS THAN (to_date('||chr(39)||
	         replace(to_char(add_months(to_date((substr(partition_name,instr(partition_name,'_',1)+1,8)||'01'),'yyyy_mm_dd'),(v_granularity+1)),'yyyy_mm_dd'),'_','-')
	         ||chr(39)||','||chr(39)||'yyyy-mm-dd'||chr(39)||'))'
	into v_partition,v_table_part_range 
	from all_tab_partitions
	where table_owner = i_schema
	and table_name = i_tabname
	and partition_name <> 'PARTCF'
	and partition_position = (select max(partition_position)
	from all_tab_partitions where table_owner = i_schema
	and table_name = i_tabname);


  ELSE


	select 'P'||to_char(to_number(substr(partition_name,2,
	         instr(partition_name,'_',1)-2))+1)||'_'||         to_char(to_date(substr(partition_name,
	         instr(partition_name,'_',1)+1),'yyyy_mm_dd')+v_granularity,'yyyy_mm_dd')
	         ,'  VALUES LESS THAN (to_date('||chr(39)||
	         replace(to_char(to_date(substr(partition_name,        instr(partition_name,'_',1)+1),'yyyy_mm_dd')+(v_granularity+1),'yyyy_mm_dd'),'_','-')
	         ||chr(39)||','||chr(39)||'yyyy-mm-dd'||chr(39)||'))'
	into v_partition,v_table_part_range 
	from all_tab_partitions
	where table_owner = i_schema
	and table_name = i_tabname
	and partition_name <> 'PARTCF'
	and partition_position = (select max(partition_position)
	from all_tab_partitions where table_owner = i_schema
	and table_name = i_tabname);
  END IF ;
	                           
  --
  -- attach it
  -- 
   v_dynStmt := 'ALTER TABLE ' || i_schema || '.' ||  i_tabname ||' ADD PARTITION ' || v_partition ||' ' || ' '  || v_table_part_range ;

  exec_sql_and_log(i_tabname, i_schema, v_partition, i_preview_only_ind,  v_dynStmt, o_sqlcode );


END ATTACH_PARTITION;
/
show errors;


