---------------------------------------------------------------------------------
--
-- Update Consortium Record Length
--
---------------------------------------------------------------------------------
update frh_property
 set property_value = 'recfm=F lrecl=9160'
  ,lstupdt_user=(SELECT SYS_CONTEXT ('USERENV', 'SESSION_USER') FROM DUAL)
  ,lstupdt_timestamp=(select current_timestamp from dual) 
  ,LSTUPDT_NBR = LSTUPDT_NBR+1
where property_name='CONSORT_FLOPT';

commit;
---------------------------------------------------------------------------------
--
-- Add new Property to have Consortium run recovery or not
--
---------------------------------------------------------------------------------
merge into FRH_PROPERTY p
USING (select 'CONSORT_SOR_CHECK' as property_name from dual) ac
                  ON (p.PROPERTY_NAME = ac.PROPERTY_NAME)
when not matched then
insert (
    PROPERTY_ID,PROPERTY_NAME, PROPERTY_VALUE, PROPERTY_DESC, PROPERTY_LABEL, PROPERTY_TYPE, 
    CREATE_TIMESTAMP, CREATE_USER, LSTUPDT_USER, LSTUPDT_TIMESTAMP, LSTUPDT_NBR, LOGICAL_DEL_IND, 
    PROPERTY_EDITABLE_IND, PROPERTY_SUB_TYPE, PROPERTY_SUB_TYPE_LABEL) 
VALUES (
 property_seq.nextval
 ,'CONSORT_SOR_CHECK' 
 , 'N'
 , 'Check the SOR for missing records'
 , 'Consortium check SOR option'        
 , 'consort'
 ,  SYS_EXTRACT_UTC(CURRENT_TIMESTAMP) 
 ,  'system'  
 ,  'system'  
 ,  SYS_EXTRACT_UTC(CURRENT_TIMESTAMP) 
 , 0
 , '0'
 , '1'
 , 'DEFAULT'
 , 'DEFAULT')
;
commit;
---------------------------------------------------------------------------------
--
-- Insert version release 3.3.1.5 (3.3 M1 HF5)
--
---------------------------------------------------------------------------------
insert into frh_version(VERSION_NAME , VERSION_NUM , VERSION_DATE , VERSION_DESC, VERSION_COMPONENT) VALUES
('Base DDL', '3.3.1.5', current_date, '3.3 M1 HF5 DDL', 'DDL') ;
commit;