

  CREATE OR REPLACE PROCEDURE UPD_XACT_FRAUD_FLAG (
     I_TABNAME    IN VARCHAR2,
     I_ALERT_ID    IN NUMBER,
     I_ALERT_VERSION_NBR IN NUMBER,     
     I_ALERT_TYPE IN VARCHAR2,
     I_RESULT_ID    IN NUMBER,     
     I_USER_NAME    IN VARCHAR2,
     I_FRAUD_IND    IN VARCHAR2,
     I_ELEMENT_COUNT    IN NUMBER,
     I_TRANSACTION_ID_1    IN NUMBER,
     I_TRANSACTION_ID_2    IN NUMBER,
     I_TRANSACTION_ID_3    IN NUMBER,
     I_TRANSACTION_ID_4    IN NUMBER,
     I_TRANSACTION_ID_5    IN NUMBER,
     I_TRANSACTION_ID_6    IN NUMBER,
     I_TRANSACTION_ID_7    IN NUMBER,
     I_TRANSACTION_ID_8    IN NUMBER,
     I_TRANSACTION_ID_9    IN NUMBER,
     I_TRANSACTION_ID_10    IN NUMBER,
     I_TRANSACTION_ID_11    IN NUMBER,
     I_TRANSACTION_ID_12    IN NUMBER,
     I_TRANSACTION_ID_13    IN NUMBER,
     I_TRANSACTION_ID_14    IN NUMBER,
     I_TRANSACTION_ID_15    IN NUMBER,
     I_TRANSACTION_ID_16    IN NUMBER,
     I_TRANSACTION_ID_17    IN NUMBER,
     I_TRANSACTION_ID_18    IN NUMBER,
     I_TRANSACTION_ID_19    IN NUMBER,
     I_TRANSACTION_ID_20    IN NUMBER,
     I_TRANSACTION_ID_21    IN NUMBER,
     I_TRANSACTION_ID_22    IN NUMBER,
     I_TRANSACTION_ID_23    IN NUMBER,
     I_TRANSACTION_ID_24    IN NUMBER,
     I_TRANSACTION_ID_25    IN NUMBER,
     I_TRANSACTION_ID_26    IN NUMBER,
     I_TRANSACTION_ID_27    IN NUMBER,
     I_TRANSACTION_ID_28    IN NUMBER,
     I_TRANSACTION_ID_29    IN NUMBER,
     I_TRANSACTION_ID_30    IN NUMBER,
     I_TRANSACTION_ID_31    IN NUMBER,
     I_TRANSACTION_ID_32    IN NUMBER,
     I_TRANSACTION_ID_33    IN NUMBER,
     I_TRANSACTION_ID_34    IN NUMBER,
     I_TRANSACTION_ID_35    IN NUMBER,
     I_TRANSACTION_ID_36    IN NUMBER,
     I_TRANSACTION_ID_37    IN NUMBER,
     I_TRANSACTION_ID_38    IN NUMBER,
     I_TRANSACTION_ID_39    IN NUMBER,
     I_TRANSACTION_ID_40    IN NUMBER,
     I_TRANSACTION_ID_41    IN NUMBER,
     I_TRANSACTION_ID_42    IN NUMBER,
     I_TRANSACTION_ID_43    IN NUMBER,
     I_TRANSACTION_ID_44    IN NUMBER,
     I_TRANSACTION_ID_45    IN NUMBER,
     I_TRANSACTION_ID_46    IN NUMBER,
     I_TRANSACTION_ID_47    IN NUMBER,
     I_TRANSACTION_ID_48    IN NUMBER,
     I_TRANSACTION_ID_49    IN NUMBER,
     I_TRANSACTION_ID_50    IN NUMBER,
     I_NEED_TO_COMMIT    VARCHAR2 )

-----------------------------------------------------------------------------
-- File:  UPD_XACT_FRAUD_FLAG.SQL
--
--
-- Description:
--     Sets or unsets the cmx_user_fraud_ind column for a given account,
--     transaction_type, and array of transactions.
--
-- Called By:
--     SAVE_ALERT_AND_TRAN_IDS
--         SET_XACT_FRAUD_FLAG
--
-- Calls:
--     N/A
--
-- Notes:
--     Originally stolen from specific procedure UPD_XACT_FRAUD_FLA.
--
-- Usage:
--
--
-- History:
--     Date          User                Notes
--     2012/07/23    leushe              Ported from DB2
--     2013/06/21    leushe              Prevent a marking from being overwritten, if the txn is already associated with a CF alert, for the entity
--
------------------------------------------------------------------------
IS

     l_rowcount INTEGER DEFAULT 0;
     l_selectTemplate varchar2(3000);   
     l_stmtTemplate varchar2(3000);
     l_tran_id NUMBER;
     l_pos INTEGER;
     l_length INTEGER;
  
    

      at_end SMALLINT DEFAULT 0;
     v_sqlstate VARCHAR2(5) DEFAULT '00000';     -- variable for SQLSTATE
     v_sqlcode INTEGER DEFAULT 0;      -- variable for SQLCODE

      TYPE refcur IS REF CURSOR;
      c_stmt refcur;
BEGIN
 
   l_selectTemplate := 'select cmx_tran_id from '|| i_tabname || ' where  ((cmx_cf_alert_version_'||i_alert_type||'_nbr =:1 and cmx_cf_alert_'||i_alert_type||'_id = :2) or cmx_cf_alert_'||i_alert_type||'_id is null)'
             || ' and   cmx_tran_id in (:3,:4,:5,:6,:7,:8,:9,:10,:11,:12,:13,:14,:15,:16,:17,:18,:19,:20,:21,:22,:23,:24,:25,:26,:27,:28,:29,:30,:31,:32,:33,:34,:35,:36,:37,:38,:39,:40,:41,:42,:43,:44,:45,:46,:47,:48,:49,:50,:51,:52)';

     l_stmtTemplate := ' UPDATE '|| i_tabname || ' SET cmx_user_fraud_'||i_alert_type||'_ind = (case when ( (cmx_cf_alert_'||i_alert_type||'_id = :1 and cmx_cf_alert_version_'||i_alert_type||'_nbr = :2) or cmx_cf_alert_'||i_alert_type||'_id is null) ' 
                  ||' then :3 else cmx_user_fraud_'||i_alert_type||'_ind end) '
                   ||',cmx_user_fraud_'||i_alert_type||'_timestamp = ( SYS_EXTRACT_UTC(CURRENT_TIMESTAMP) )'
                   ||',cmx_lstupdt_user = :4,cmx_lstupdt_timestamp =  ( SYS_EXTRACT_UTC(CURRENT_TIMESTAMP) )'                   
                   ||',cmx_cf_alert_'||i_alert_type||'_id = (case when ( (cmx_cf_alert_'||i_alert_type||'_id = :5 and cmx_cf_alert_version_'||i_alert_type||'_nbr = :6) or cmx_cf_alert_'||i_alert_type||'_id is null) then ' 
                ||'      CASE when (:7 = ''0'') then null else case when ( :8 = 7 ) then :9 else cmx_cf_alert_'||i_alert_type||'_id  END END ELSE cmx_cf_alert_'||i_alert_type||'_id END)'                   
                   ||',cmx_cf_alert_version_'||i_alert_type||'_nbr =    (case when ( (cmx_cf_alert_'||i_alert_type||'_id = :10 and cmx_cf_alert_version_'||i_alert_type||'_nbr = :11) or cmx_cf_alert_'||i_alert_type||'_id is null) then ' 
                  ||'       CASE when (:12 = ''0'') then null else  case when ( :13 = 7 ) then :14  else cmx_cf_alert_version_'||i_alert_type||'_nbr  END END ELSE cmx_cf_alert_version_'||i_alert_type||'_nbr END) '        
                   ||' WHERE cmx_tran_id = :15 ';
                   
     
                   
        v_sqlstate:='00000';
        at_end :=0;
        OPEN c_stmt FOR l_selectTemplate USING 
                i_alert_Version_nbr,i_alert_id, i_transaction_id_1, i_transaction_id_2, i_transaction_id_3,
                i_transaction_id_4, i_transaction_id_5, i_transaction_id_6,
                i_transaction_id_7, i_transaction_id_8, i_transaction_id_9,
                i_transaction_id_10, i_transaction_id_11, i_transaction_id_12,
                i_transaction_id_13, i_transaction_id_14, i_transaction_id_15,
                i_transaction_id_16, i_transaction_id_17, i_transaction_id_18,
                i_transaction_id_19, i_transaction_id_20, i_transaction_id_21,
                i_transaction_id_22, i_transaction_id_23, i_transaction_id_24,
                i_transaction_id_25, 
                i_transaction_id_26, i_transaction_id_27, 
                i_transaction_id_28, i_transaction_id_29, 
                i_transaction_id_30, i_transaction_id_31, i_transaction_id_32,
                i_transaction_id_33, i_transaction_id_34, i_transaction_id_35,
                i_transaction_id_36, i_transaction_id_37, i_transaction_id_38,
                i_transaction_id_39, 
                i_transaction_id_40, i_transaction_id_41, i_transaction_id_42,
                i_transaction_id_43, i_transaction_id_44, i_transaction_id_45,
                i_transaction_id_46, i_transaction_id_47, i_transaction_id_48,
                i_transaction_id_49, i_transaction_id_50 ;
    
     WHILE ( v_sqlstate = '00000'  and at_end = 0 ) LOOP
          FETCH c_stmt INTO l_tran_id ;
             IF c_stmt%NOTFOUND then
               at_end:=1;
             END IF; 
          IF ( v_sqlstate = '00000' and at_end=0 ) THEN
                
 
          
          INSERT into FMX_FRAUD_UPDT (CMX_FRAUD_UPDT_ID,CMX_TRAN_ID, TABLE_NAME, ALERT_ID,ALERT_VERSION_NBR,ALERT_TYPE, USER_FRAUD_IND,USER_FRAUD_TIMESTAMP, cmx_LSTUPDT_USER, cmx_LSTUPDT_TIMESTAMP) 
              values (fraud_updt_seq.nextval,l_tran_id,i_tabname,
              case when (i_fraud_ind='1' and i_result_id=7) then i_alert_id else null end,
              case when (i_fraud_ind='1' and i_result_id=7) then i_alert_version_nbr else null end,
               i_alert_Type,i_fraud_ind,SYS_EXTRACT_UTC(CURRENT_TIMESTAMP),i_user_name,SYS_EXTRACT_UTC(CURRENT_TIMESTAMP) );
              
        
                   
               EXECUTE IMMEDIATE l_stmtTemplate USING
                i_alert_id,i_alert_Version_nbr,i_fraud_ind, i_user_name, 
                i_alert_id,i_alert_Version_nbr,i_fraud_ind,i_result_id,i_alert_id,
                i_alert_id,i_alert_Version_nbr,i_fraud_ind,i_result_id,i_alert_Version_nbr,l_tran_id;
                
           END IF;
    END LOOP;








    -- no way to know how many records should be updated.
    -- ? why not check element_count vs. l_rowcount ?


    --
    -- The commit/rollback decision has to be handled by the caller.
    --

    IF(i_need_to_commit = 'Y') THEN
      COMMIT;
    END IF;

  END UPD_XACT_FRAUD_FLAG;


/
show errors;


